#include <stdio.h>
#include "vect.h"

int main(int argc, char *argv[]){
  printf("Test de create/resize/length/free\n");
  vect *v = vect_create();
  vect_free(v);
  v = vect_create();
  assert(vect_length(v) == 0);
  vect_resize(v, 50);
  assert(vect_length(v) == 50);
  vect_resize(v, 100);
  assert(vect_length(v) == 100);
  vect_resize(v, 5);
  assert(vect_length(v) == 5);
  vect_free(v);

  printf("Test de set/get\n");
  v = vect_create();
  vect_resize(v, 50);
  for (int i = 0; i < 50; i = i + 1){
    vect_set(v, i, i);
    assert(vect_get(v, i) == i);
  }
  vect_free(v);

  printf("Test de pushR/popR\n");
  v = vect_create();
  vect_pushR(v, 0);
  assert(vect_length(v) == 1);
  assert(vect_popR(v) == 0);
  assert(vect_length(v) == 0);
  for (int i = 0; i < 50; i = i + 1){
    vect_pushR(v, 0);
  }
  assert(vect_length(v) == 50);
  vect_pushR(v, 50);
  assert(vect_popR(v) == 50);
  for (int i = 0; i < 50; i = i + 1){
    vect_popR(v);
  }
  assert(vect_length(v) == 0);
  vect_free(v);

  return 0;
}
